using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ESRI.ArcGIS.Mobile;
using ESRI.ArcGIS.Mobile.MobileServices;
using ESRI.ArcGIS.Mobile.Geometries;
  
namespace CustomLayer_Win
{
  public partial class Form1 : Form
  {
    /// <summary>
    /// Initializes a custom graphic layer instance
    /// </summary>
    CustomGraphicLayer graphicLayer = new CustomGraphicLayer();

    /// <summary>
    /// Initializes a coordinate collection instance
    /// </summary>
    CoordinateCollection coordinateCollection = new CoordinateCollection();

    public Form1()
    {
      InitializeComponent();
    }

    private void Form1_Load(object sender, EventArgs e)
    {
    }

    private void openButton_Click(object sender, EventArgs e)
    {
      try
      {
        //To get data from your server, uncomment the mobile service url line.
        //Replace ServerName and MobileServiceName with your mobile server
        //          mobileServiceConnection1.Url = @"http://<ServerName>/arcgis/services/<MobileServiceName>/MapServer/MobileServer";
        mobileCache1.StoragePath = System.IO.Directory.GetParent(System.IO.Directory.GetParent(System.IO.Directory.GetParent(System.IO.Directory.GetCurrentDirectory()).ToString()).ToString()).ToString() + "\\MapCache";

        mobileCache1.Open();

        for (int i = 0; i < mobileCache1.Layers.Count; i++)
        {
          layerListBox.Items.Add(mobileCache1.Layers[i].Name);
        }
      }
      catch (Exception ex)
      {
        MessageBox.Show(ex.ToString());
      }
    }

    private void map1_ExtentChanged(object sender, EventArgs e)
    {
      //Uncomment this line if you want to get data from your own mobile service
    }

    private void addGraphicLayerButton_Click(object sender, EventArgs e)
    {
      if (coordinateCollection.Count == 0)
      {
        MessageBox.Show("Please click on the map to add point(s) to the custom graphic layer. Click Add Graphic Layer button again when you have added point(s) to the map.");
        return;
      }

      //if already added then return
      if (map1.MapGraphicLayers.Contains(graphicLayer))
        return;

      graphicLayer.Coordinates = coordinateCollection;

      //Add custom graphic layer to MapGraphicLayers collection
      map1.MapGraphicLayers.Add(graphicLayer);

      //Get the layer name from custom map graphic layer
      layerNameLabel.Text = graphicLayer.LayerName;

    }

    private void collectButton_Click(object sender, EventArgs e)
    {
      
    }


    private void map1_MouseUp(object sender, MapMouseEventArgs e)
    {
      Coordinate coord = map1.ToMap(e.X, e.Y);

      coordinateCollection.Add(coord);

      coord = mobileCache1.SpatialReference.ToWgs84(coord);

      coordTextBox.Text += "(" + coord.X.ToString("#0.000000") + " ," + coord.Y.ToString("#0.000000") + ")\r\n";
    }

    private void removeLayerButton_Click(object sender, EventArgs e)
    {
      map1.MapGraphicLayers.Remove(graphicLayer);
      graphicLayer = new CustomGraphicLayer();
      layerNameLabel.Text = "";
    }

    private void clearCoordinateButton_Click(object sender, EventArgs e)
    {
      coordinateCollection = new CoordinateCollection();
      coordTextBox.Text = "";
    }






  }
}